config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  root 'todo_lists#index'
  resources :todo_lists do
    resources :todos
  end
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/todo.rb
# frozen_string_literal: true

class Todo < ApplicationRecord
  belongs_to :todo_list

  validates_presence_of :description
end

app/models/todo_list.rb
# frozen_string_literal: true

class TodoList < ApplicationRecord
  validates_presence_of :title
  has_many :todos, dependent: :destroy
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/todo_lists_controller.rb
# frozen_string_literal: true

class TodoListsController < ApplicationController
  before_action :set_todo_list, only: %i[show edit update destroy]

  # GET /todo_lists
  # GET /todo_lists.json
  def index
    @todo_lists = TodoList.all
  end

  # GET /todo_lists/1
  # GET /todo_lists/1.json
  def show; end

  # GET /todo_lists/new
  def new
    @todo_list = TodoList.new
  end

  # GET /todo_lists/1/edit
  def edit; end

  # POST /todo_lists
  # POST /todo_lists.json
  def create
    @todo_list = TodoList.new(todo_list_params)

    respond_to do |format|
      if @todo_list.save
        format.html { redirect_to @todo_list, notice: 'Todo list was successfully created.' }
        format.json { render :show, status: :created, location: @todo_list }
      else
        format.html { render :new }
        format.json { render json: @todo_list.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /todo_lists/1
  # PATCH/PUT /todo_lists/1.json
  def update
    respond_to do |format|
      if @todo_list.update(todo_list_params)
        format.html { redirect_to @todo_list, notice: 'Todo list was successfully updated.' }
        format.json { render :show, status: :ok, location: @todo_list }
      else
        format.html { render :edit }
        format.json { render json: @todo_list.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /todo_lists/1
  # DELETE /todo_lists/1.json
  def destroy
    @todo_list.destroy
    respond_to do |format|
      format.html { redirect_to todo_lists_url, notice: 'Todo list was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_todo_list
    @todo_list = TodoList.find(params[:id])
    @todos = Todo.where(todo_list_id: params[:id])
  end

  # Only allow a list of trusted parameters through.
  def todo_list_params
    params.require(:todo_list).permit(:title)
  end
end

app/controllers/todos_controller.rb
# frozen_string_literal: true

class TodosController < ApplicationController
  before_action :get_todo_list
  before_action :set_todo, only: %w[show edit update destroy]

  # GET /todos
  # GET /todos.json
  def index
    @todos = @todo_list.todos
  end

  # GET /todos/1
  # GET /todos/1.json
  def show; end

  # GET /todos/new
  def new
    @todo = @todo_list.todos.build
  end

  # GET /todos/1/edit
  def edit; end

  # POST /todos
  # POST /todos.json
  def create
    @todo = @todo_list.todos.build(todo_params)

    respond_to do |format|
      if @todo.save
        format.html { redirect_to @todo_list, notice: 'Todo was successfully created.' }
        format.json { render :show, status: :created, location: @todo }
      else
        format.html { render :new }
        format.json { render json: @todo.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /todos/1
  # PATCH/PUT /todos/1.json
  def update
    respond_to do |format|
      if @todo.update(todo_params)
        format.html { redirect_to @todo_list, notice: 'Todo was successfully updated.' }
        format.json { render :show, status: :ok, location: @todo }
      else
        format.html { render :edit }
        format.json { render json: @todo.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /todos/1
  # DELETE /todos/1.json
  def destroy
    @todo.destroy
    respond_to do |format|
      format.html { redirect_to @todo_list, notice: 'Todo was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.

  def get_todo_list
    @todo_list = TodoList.find(params[:todo_list_id])
  end

  def set_todo
    @todo = Todo.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def todo_params
    params.require(:todo).permit(:description)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/todo_list_helper.rb
module TodoListHelper
end

app/helpers/todo_lists_helper.rb
module TodoListsHelper
end

app/helpers/todos_helper.rb
module TodosHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Rakolyst</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/todo_lists/_form.html.erb
<%= form_for(@todo_list) do |f| %>
  <% if @todo_list.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@todo_list.errors.count, "error") %> prohibited this todo_list from being saved:</h2>

      <ul>
      <% @todo_list.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :title %><br>
    <%= f.text_field :title %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/todo_lists/edit.html.erb
<h1>Editing Todo List</h1>

<%= render 'form', todo_list: @todo_list %>

<%= link_to 'Show', @todo_list %> |
<%= link_to 'Back', todo_lists_path %>

app/views/todo_lists/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Todo Lists</h1>

<table>
    <thead>
        <tr>
            <th colspan="3"></th>
        </tr>
    </thead>

    <tbody>
        <% @todo_lists.each do |todo_list| %>
        <tr>
            <td><%= todo_list.title %></td>
            <td><%= link_to 'Show', todo_list %></td>
            <td><%= link_to 'Edit', edit_todo_list_path(todo_list) %></td>
            <td><%= link_to 'Destroy', todo_list, method: :delete, data: { confirm: 'Are you sure?' } %></td>
        </tr>
        <% end %>
    </tbody>
</table>

<br>

<%= link_to 'New Todo List', new_todo_list_path %>

app/views/todo_lists/new.html.erb
<h1>New Todo List</h1>

<%= render 'form', todo_list: @todo_list %>

<%= link_to 'Back', todo_lists_path %>

app/views/todo_lists/show.html.erb
<h1> <%= @todo_list.title %> </h1>
<p id="notice"><%= notice %></p>
<table>
    <tbody>
        <% @todos.each do |todo| %>
        <tr>
            <td><%= todo.description %></td>
            <td><%= todo.id %> </td>
            <td><%= todo.todo_list_id %> </td>
            <td><%= link_to 'Edit', edit_todo_list_todo_path(@todo_list, todo) %></td>
            <td><%= link_to 'Destroy', todo_list_todo_path(@todo_list, todo), method: :delete, data: { confirm: 'Are you sure?' } %></td>
        </tr>
        <% end %>
    </tbody>
</table>
<%= link_to 'Add Todo', new_todo_list_todo_path(@todo_list) %>
<%= link_to 'Edit', edit_todo_list_path(@todo_list) %> |
<%= link_to 'Back', todo_lists_path %>

app/views/todos/_form.html.erb
<%= form_with(model: [@todo_list, todo], local: true) do |f| %>
  <% if todo.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(todo.errors.count, "error") %> prohibited this todo from being saved:</h2>

      <ul>
      <% todo.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  <div class="field">
    <%= f.label :description %><br>
    <%= f.text_area :description %>
  </div>
  <div class="field">
    <%= f.label :completed %><br>
    <%= f.check_box :completed %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/todos/edit.html.erb
<h1>Editing Todo</h1>

<%= render 'form', todo: @todo %>
|
<%= link_to 'Back', todo_lists_path(@todo_list) %>

app/views/todos/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Todos</h1>

<table>
  <thead>
    <tr>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @todos.each do |todo| %>
      <tr>
        <td><%= link_to 'Show', todo %></td>
        <td><%= link_to 'Edit', edit_todo_path(todo) %></td>
        <td><%= link_to 'Destroy', todo, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Todo', new_todo_path %>

app/views/todos/new.html.erb
<h1>New Todo</h1>

<%= render 'form', todo: @todo %>

<%= link_to 'Back', :back %>

app/views/todos/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Edit', edit_todo_path(@todo) %> |
<%= link_to 'Back', todos_path %>